-module(load_average).
-export([get/0]).
-on_load(init/0).

-ifdef(TEST).
-include_lib("eunit/include/eunit.hrl").
-endif.

init() ->
    case code:which(load_average) of
        Filename when is_list(Filename) ->
            erlang:load_nif(filename:join([filename:dirname(Filename),
                                           "..","priv",
                                           "load_average"]), []);
        Reason when is_atom(Reason) ->
            {error, Reason}
    end.

-spec get() -> {ok, {float(),float(),float()}} | { error, atom() }.
% @doc Returns system load average
get() ->
    erlang:nif_error(nif_library_not_loaded).

-ifdef(TEST).
get_test() ->
    {ok,{X,Y,Z}} = ?MODULE:get(),
    true = is_float(X),
    true = is_float(Y),
    true = is_float(Z).
-endif.
